routes/web.php
<?php

Auth::routes();

Route::get('/', 'WelcomeController@welcome');

Route::get('/home', 'HomeController@index')->name('home');

Route::group(['prefix' => 'admin'], function()  {

    Route::resource('users', 'UserController')->middleware('role:HR_Manager');
    Route::resource('roles', 'RoleController')->middleware('role:HR_Manager');
    Route::resource('permissions', 'PermissionController')->middleware('role:HR_Manager');
    Route::resource('nationalities', 'NationalityController')->middleware('role:HR_Manager|HR_Employee');
}); 

Route::get('users/{id}/changeState', 'UserController@changeState')->name('users.changeState')->middleware('role:HR_Manager');

Route::get('nationalities/{id}/changeState', 'NationalityController@changeState')->name('nationalities.changeState')->middleware('role:HR_Manager|HR_Employee');

Route::resource('jobs', 'JobController')->middleware('role:HR_Manager');

Route::get('jobs/{id}/changeState', 'JobController@changeState')->name('jobs.changeState')->middleware('role:HR_Manager');

Route::resource('canceled_jobs', 'CanceledJobController')->middleware('role:HR_Manager');

Route::get('canceled_jobs/{id}/changeState', 'CanceledJobController@changeState')->name('canceled_jobs.changeState')->middleware('role:HR_Manager');

Route::resource('qualifications', 'QualificationController')->middleware('role:HR_Manager|HR_Employee');

Route::get('qualifications/{id}/changeState', 'QualificationController@changeState')->name('qualifications.changeState')->middleware('role:HR_Manager|HR_Employee');

Route::resource('jobs_descriptions', 'JobsDescriptionController')->middleware('role:HR_Manager|HR_Employee');

Route::get('jobs_descriptions/{id}/changeState', 'JobsDescriptionController@changeState')->name('jobs_descriptions.changeState')->middleware('role:HR_Manager|HR_Employee');

Route::resource('classes_contracts', 'ClassesContractController')->middleware('role:HR_Manager|HR_Employee');

Route::get('classes_contracts/{id}/changeState', 'ClassesContractController@changeState')->name('classes_contracts.changeState')->middleware('role:HR_Manager|HR_Employee');

Route::resource('jobs_level', 'JobsLevelController')->middleware('role:HR_Manager|HR_Employee');

Route::get('jobs_level/{id}/changeState', 'JobsLevelController@changeState')->name('jobs_level.changeState')->middleware('role:HR_Manager|HR_Employee');

Route::resource('social_situations', 'SocialSituationController')->middleware('role:HR_Manager|HR_Employee');

Route::get('social_situations/{id}/changeState', 'SocialSituationController@changeState')->name('social_situations.changeState')->middleware('role:HR_Manager|HR_Employee');

Route::resource('employees', 'EmployeeController')->middleware('role:HR_Manager|HR_Employee');

Route::get('employees/{id}/changeState', 'EmployeeController@changeState')->name('employees.changeState')->middleware('role:HR_Manager|HR_Employee');

Route::resource('courses', 'CourseController')->middleware('role:HR_Manager|HR_Employee');

Route::get('courses/{id}/changeState', 'CourseController@changeState')->name('courses.changeState')->middleware('role:HR_Manager|HR_Employee');

Route::resource('employee_courses', 'EmployeesCourseController')->middleware('role:HR_Manager|HR_Employee');

Route::get('employee_courses/{id}/changeState', 'EmployeesCourseController@changeState')->name('employee_courses.changeState')->middleware('role:HR_Manager|HR_Employee');

Route::resource('assignments', 'AssignmentController')->middleware('role:HR_Manager|HR_Employee');

Route::get('employee_trans', 'AssignmentController@employeeTrans')->name('employee_trans')->middleware('role:HR_Manager|HR_Employee');

Route::resource('employees_qualifications', 'EmployeeQualificationController')->middleware('role:HR_Manager|HR_Employee');

Route::get('employees_qualifications/{id}/changeState', 'EmployeeQualificationController@changeState')->name('employees_qualifications.changeState')->middleware('role:HR_Manager|HR_Employee');

Route::resource('employee_cotracts', 'EmployeeCotractController')->middleware('role:HR_Manager|HR_Employee');

Route::get('employee/cotracts/{employee}', 'EmployeeCotractController@new')->name('employee_cotracts.new')->middleware('role:HR_Manager|HR_Employee');

Route::get('employee/cotracts/{employee}/renew', 'EmployeeCotractController@renew')->name('employee_cotracts.renewv')->middleware('role:HR_Manager|HR_Employee');

Route::post('employee/cotracts/{employee}/renew', 'EmployeeCotractController@renewPost')->name('employee_cotracts.renew')->middleware('role:HR_Manager|HR_Employee');

Route::get('employee/cotracts/{id}/decline', 'EmployeeCotractController@decline')->name('employee_cotracts.decline')->middleware('role:HR_Manager|HR_Employee');

Route::get('employee_cotracts/{id}/changeState', 'EmployeeCotractController@changeState')->name('employee_cotracts.changeState')->middleware('role:HR_Manager|HR_Employee');

Route::resource('structures', 'StructureController')->middleware('role:HR_Manager');

Route::get('structures/{id}/changeState', 'StructureController@changeState')->name('structures.changeState')->middleware('role:HR_Manager');

Route::resource('efficiencies', 'EfficiencyController')->middleware('role:HR_Manager|Basic_User');

Route::get('efficiencies/{employee_id}/{year}/show', 'EfficiencyController@show')->name('efficiencies.show')->middleware('role:HR_Manager|Basic_User');

Route::get('efficiencies/{employee_id}/{year}/edit', 'EfficiencyController@edit')->name('efficiencies.edit')->middleware('role:HR_Manager|Basic_User');

Route::resource('overdue', 'OverdueController')->middleware('role:HR_Manager');

Route::get('overdue/{employee}/putin', 'OverdueController@putin')->name('overdue.putin')->middleware('role:HR_Manager');

Route::get('overdue/{employee}/putout', 'OverdueController@putout')->name('overdue.putout')->middleware('role:HR_Manager|HR_Employee');

Route::get('profile', 'ProfileController@show')->name('profile.show');

Route::get('profile/edit', 'ProfileController@edit')->name('profile.edit');

Route::put('profile', 'ProfileController@update')->name('profile.update');

Route::get('jobOpportunities', 'ReportController@jobOpportunities')->name('jobOpportunities')->middleware('role:HR_Manager|HR_Employee');

Route::get('jobNotOpportunities', 'ReportController@jobNotOpportunities')->name('jobNotOpportunities')->middleware('role:HR_Manager|HR_Employee');

Route::get('jobcanceled', 'ReportController@jobcanceled')->name('jobcanceled')->middleware('role:HR_Manager|HR_Employee');

app/Assignment.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Assignment extends Model
{
    public function employee()
    {
        return $this->belongsTo(Employee::class);
    }

    public function jobdescription()
    {
        return $this->belongsTo(JobsDescription::class, 'job_description_id', 'id');
    }

    public function oldemployee()
    {
        return $this->belongsTo(Employee::class, 'old_employee_id', 'id');
    }

    public function job()
    {
        return $this->belongsTo(Job::class);
    }
}

app/Http/Controllers/AssignmentController.php
<?php

namespace App\Http\Controllers;

use App\Job;
use App\Employee;
use App\Structure;
use App\Assignment;
use App\JobsDescription;
use Illuminate\Http\Request;
use App\Rules\AlphaSpacer;
class AssignmentController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $assignments = Assignment::all();
        return view('assignments.index')->with('assignments', $assignments);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $employees = Employee::where('active',true)->where('overdue',true)->get();
        $jobs_descriptions  = JobsDescription::where('active',true)->get();
        // $structures  = Structure::where('active',true)->get();
        $jobs   = Job::where('active',true)->get();

        $data = [
            'employees' => $employees,
            'jobs_descriptions' => $jobs_descriptions,
            // 'structures' => $structures,
            'jobs' => $jobs,
        ];

        return view ('assignments.create')->with($data);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $rules = [
            'employee_id' => 'required|integer|exists:employees,id',
            'old_employee_id' => 'required|integer|different:employee_id|exists:employees,id',
            'job_description_id' => 'required|integer|exists:jobs_descriptions,id',
            // 'structure_id' => 'required|integer|exists:structures,id',
            'job_id' => 'required|integer|exists:jobs,id',
            'start_date' => 'required|date',
            'end_date' => 'required|date|after_or_equal:start_date',
            'reason' => 'required|string|max:100',
        ];

        $messages = [
        ];
        
        $this->validate($request, $rules, $messages);

        $assignment = new Assignment();
        $assignment->employee_id = $request->employee_id;
        $assignment->job_description_id = $request->job_description_id;
        $assignment->job_id = $request->job_id;
        $assignment->old_employee_id = $request->old_employee_id;
        $assignment->start_date = $request->start_date;
        $assignment->end_date = $request->end_date;
        $assignment->reason = $request->reason;
        // $assignment->structure_id = $request->structure_id;
        $assignment->save();

        return redirect()->route('assignments.index')->with('success','تمت عملية إضافة التكليف للموظف بنجاح');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Assignment  $assignment
     * @return \Illuminate\Http\Response
     */
    public function show(Assignment $assignment)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Assignment  $assignment
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $employees = Employee::where('active',true)->where('overdue',true)->get();
        $jobs_descriptions  = JobsDescription::where('active',true)->get();
        $jobs   = Job::where('active',true)->get();
        // $structures  = Structure::where('active',true)->get();
        $assignment   = Assignment::findOrFail($id);

        $data = [
            'employees' => $employees,
            'jobs_descriptions' => $jobs_descriptions,
            'jobs' => $jobs,
            // 'structures' => $structures,
            'assignment' => $assignment,
        ];

        return view ('assignments.edit')->with($data);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Assignment  $assignment
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $rules = [
            'employee_id' => 'required|integer|exists:employees,id',
            'old_employee_id' => 'required|integer|different:employee_id|exists:employees,id',
            'job_description_id' => 'required|integer|exists:jobs_descriptions,id',
            // 'structure_id' => 'required|integer|exists:structures,id',
            'job_id' => 'required|integer|exists:jobs,id',
            'start_date' => 'required|date',
            'end_date' => 'required|date|after_or_equal:start_date',
            'reason' => 'required|string|max:100',
        ];

        $messages = [
        ];
        
        $this->validate($request, $rules, $messages);

        $assignment   = Assignment::findOrFail($id);
        $assignment->employee_id = $request->employee_id;
        $assignment->job_description_id = $request->job_description_id;
        $assignment->job_id = $request->job_id;
        $assignment->old_employee_id = $request->old_employee_id;
        $assignment->start_date = $request->start_date;
        $assignment->end_date = $request->end_date;
        $assignment->reason = $request->reason;
        // $assignment->structure_id = $request->structure_id;
        $assignment->save();

        return redirect()->route('assignments.index')->with('success','تمت عملية تعديل التكليف للموظف بنجاح');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Assignment  $assignment
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $assignment = Assignment::findOrFail($id);
        $assignment->delete();

        return redirect()->route('assignments.index')->with('success','تمت عملية حذف التكليف بنجاح');
    }
    
   
}

resources/views/assignments/create.blade.php
@extends('layouts.main')

@section('title')
    تكليفات الموظفين
@endsection

@section('content')

    <div class="card">
        <div class="card-body">
            <h4 class="header-title">إضافة تكليف</h4>
            <form action="{{route('assignments.store')}}" method="POST">
                @csrf

                <div class="row">
                    <div class="col col-md-6">
                        <div class="form-group focused">
                            <label class="form-control-label">الموظف المراد تكليفة</label>
                            <select class="form-control" name="employee_id">
                                <option value="-1">اختار الموظف</option>
                                @foreach ($employees as $employee)
                                    <option value="{{ $employee->id }}"  {{ old('employee_id') == $employee->id ? 'selected': '' }}  >{{ $employee->first_name }} {{ $employee->mid_name }} {{ $employee->last_name }}</option>
                                @endforeach
                            </select>                                
                        </div>
                    </div>
                    <div class="col col-md-6">
                        <div class="form-group focused">
                            <label class="form-control-label">الموظف القديم</label>
                            <select class="form-control" name="old_employee_id">
                                <option value="-1">اختار الموظف</option>
                                @foreach ($employees as $employee)
                                    <option value="{{ $employee->id }}" {{ old('old_employee_id') == $employee->id ? 'selected': '' }}  >{{ $employee->first_name }} {{ $employee->mid_name }} {{ $employee->last_name }}</option>
                                @endforeach
                            </select>                                
                        </div>
                    </div>
                </div>

                <div class="row">
                    <div class="col col-md-6">
                        <div class="form-group focused">
                            <label class="form-control-label">الوظيفة</label>
                            <select class="form-control" name="job_id">
                                <option value="-1">الوظيفة</option>
                                @foreach ($jobs as $job)
                                    <option value="{{ $job->id }}" {{ old('job_id') == $job->id ? 'selected': '' }}> {{ $job->name }}</option>
                                @endforeach
                            </select>                                
                        </div>
                    </div>
                    
                    <div class="col col-md-6">
                        <div class="form-group ">
                            <label class="form-control-label">المسمى الوظيفي</label>
                            <select class="form-control" name="job_description_id">
                                <option value="-1">المسمى الوظيفي</option>
                                @foreach ($jobs_descriptions as $job_description)
                                    <option value="{{ $job_description->id }}" {{ old('job_description_id') == $job_description->id ? 'selected': '' }} >{{ $job_description->name }}</option>
                                @endforeach
                            </select>                                
                        </div>
                    </div>
                </div>

                <div class="row">
                    <div class="col col-md-6">
                        <div class="form-group ">
                            <label class="form-control-label">تاريح البداية</label>
                            <input type="date" name="start_date" value="{{ old('start_date') }}" class="form-control" placeholder="تاريخ البداية" >
                        </div>
                    </div>
                    <div class="col col-md-6">
                        <div class="form-group ">
                            <label class="form-control-label">تاريح النهاية</label>
                            <input type="date" name="end_date"  value="{{ old('end_date') }}" class="form-control" placeholder="تاريح النهاية" >
                        </div>
                    </div>

                </div>

                <div class="row">
                    <div class="col col-md-6">
                        <div class="form-group ">
                            <label class="form-control-label">سبب التكليف</label>
                            <textarea name="reason" class="form-control custome-font" placeholder="سبب التكليف" > {{ old('reason') }}  </textarea>
                        </div>
                    </div>
                    {{-- <div class="col col-md-6">
                        <div class="form-group focused">
                            <label class="form-control-label">تبعية الهيكل الوظيفي</label>
                            <select class="form-control" name="structure_id">
                                <option value="-1">تبعية الهيكل الوظيفي</option>
                                @foreach ($structures as $structure)
                                    <option value="{{ $structure->id }}">{{ $structure->name }}</option>
                                @endforeach
                            </select>                                
                        </div>
                    </div> --}}
                </div>

                <div class="form-group">
                    <button type="submit" class="btn btn-success btn-rounded btn-fw custome-font">إضافة تكليف</button>
                    <a href="{{ route('assignments.index') }}" class="btn btn-light btn-rounded btn-fw custome-font">إلغاء الأمر</a>
                </div>
            </form>
        </div>
    </div>
@endsection

resources/views/assignments/edit.blade.php
@extends('layouts.main')

@section('title')
    تكليفات الموظفين
@endsection

@section('content')

    <div class="card">
        <div class="card-body">
            <h4 class="header-title">تعديل تكليف</h4>
            <form action="{{route('assignments.update', $assignment->id )}}" method="POST">
                @csrf
                @method('PUT')

                <div class="row">
                    <div class="col col-md-6">
                        <div class="form-group focused">
                            <label class="form-control-label">الموظف المراد تكليفة</label>
                            <select class="form-control" name="employee_id">
                                <option value="-1">اختار الموظف</option>
                                @foreach ($employees as $employee)
                                    <option value="{{ $employee->id }}" {{ $assignment->employee_id == $employee->id ? 'selected': '' }} >{{ $employee->first_name }} {{ $employee->mid_name }} {{ $employee->last_name }}</option>
                                @endforeach
                            </select>                                
                        </div>
                    </div>
                    <div class="col col-md-6">
                        <div class="form-group focused">
                            <label class="form-control-label">الموظف القديم</label>
                            <select class="form-control" name="old_employee_id">
                                <option value="-1">اختار الموظف</option>
                                @foreach ($employees as $employee)
                                    <option value="{{ $employee->id }}" {{ $assignment->old_employee_id == $employee->id ? 'selected': '' }} >{{ $employee->first_name }} {{ $employee->mid_name }} {{ $employee->last_name }}</option>
                                @endforeach
                            </select>                                
                        </div>
                    </div>
                </div>

                <div class="row">
                    <div class="col col-md-6">
                        <div class="form-group focused">
                            <label class="form-control-label">الوظيفة</label>
                            <select class="form-control" name="job_id">
                                <option value="-1">الوظيفة</option>
                                @foreach ($jobs as $job)
                                    <option value="{{ $job->id }}" {{ $assignment->job_id == $job->id ? 'selected': '' }} > {{ $job->name }}</option>
                                @endforeach
                            </select>                                
                        </div>
                    </div>
                    
                    <div class="col col-md-6">
                        <div class="form-group ">
                            <label class="form-control-label">المسمى الوظيفي</label>
                            <select class="form-control" name="job_description_id">
                                <option value="-1">المسمى الوظيفي</option>
                                @foreach ($jobs_descriptions as $job_description)
                                    <option value="{{ $job_description->id }}" {{ $assignment->job_description_id == $job_description->id ? 'selected': '' }}>{{ $job_description->name }}</option>
                                @endforeach
                            </select>                                
                        </div>
                    </div>
                </div>

                <div class="row">
                    <div class="col col-md-6">
                        <div class="form-group ">
                            <label class="form-control-label">تاريح البداية</label>
                            <input type="date" name="start_date" value="{{ $assignment->start_date }}" class="form-control" placeholder="تاريخ البداية" >
                        </div>
                    </div>
                    <div class="col col-md-6">
                        <div class="form-group ">
                            <label class="form-control-label">تاريح النهاية</label>
                            <input type="date" name="end_date" value="{{ $assignment->end_date }}" class="form-control" placeholder="تاريح النهاية" >
                        </div>
                    </div>

                </div>

                <div class="row">
                    <div class="col col-md-6">
                        <div class="form-group ">
                            <label class="form-control-label">سبب التكليف</label>
                            <textarea name="reason" class="form-control custome-font" placeholder="سبب التكليف" >{{ $assignment->reason }}</textarea>
                        </div>
                    </div>
                    {{-- <div class="col col-md-6">
                        <div class="form-group focused">
                            <label class="form-control-label">تبعية الهيكل الوظيفي</label>
                            <select class="form-control" name="structure_id">
                                <option value="-1">تبعية الهيكل الوظيفي</option>
                                @foreach ($structures as $structure)
                                    <option value="{{ $structure->id }}" {{ $assignment->structure_id == $structure->id ? 'selected': '' }}>{{ $structure->name }}</option>
                                @endforeach
                            </select>                                
                        </div>
                    </div> --}}
                </div>

                <div class="form-group">
                    <button type="submit" class="btn btn-success btn-rounded btn-fw custome-font">تعديل التكليف</button>
                    <a href="{{ route('assignments.index') }}" class="btn btn-light btn-rounded btn-fw custome-font">إلغاء الأمر</a>
                </div>
            </form>
        </div>
    </div>
@endsection

resources/views/assignments/index.blade.php
@extends('layouts.main')

@section('title')
    تكليفات الموظفين
@endsection

@section('content')
    <div class="card">
        <div class="card-body">
            <h4 class="header-title">قائمة تكليفات الموظفين</h4>
            <div class="clearfix">
                <a href="{{route('assignments.create')}}" class="btn btn-success btn-rounded btn-fw clearfix">إضافة تكليف</a>
            </div>
            <br>
            <div class="single-table">
                <div class="table-responsive">
                    <table class="table ">
                        <thead class="text-uppercase bg-light">
                            <tr>
                                <th>#رقم</th>
                                <th>الموظف المكلف</th>
                                <th>الموظف القديم</th>
                                <th>المسمى الوظيفي</th>
                                <th>الوظيفة</th>
                                <th>التاريخ</th>
                                <th>السبب</th>
                                <th>التحكم</th>
                            </tr>
                        </thead>
                        <tbody>
                        @foreach ($assignments as $index=>$assignment)
                            <tr>
                                <td>{{$index + 1}}</td>
                                <td>
                                    {{$assignment->employee->first_name}}
                                    {{$assignment->employee->mid_name}}
                                    {{$assignment->employee->last_name}}
                                    {{$assignment->employee->family_name}}
                                </td>
                                <td>
                                    {{$assignment->oldemployee->first_name}}
                                    {{$assignment->oldemployee->mid_name}}
                                    {{$assignment->oldemployee->last_name}}
                                    {{$assignment->oldemployee->family_name}}
                                </td>
                                <td>{{$assignment->jobdescription->name}}</td>
                                <td>{{$assignment->job->name}}</td>
                                
                                <td>
                                    <div class="row">
                                        <div class="badge badge-success"> تاريخ البداية {{$assignment->start_date}}</div>
                                    </div>
                                    <br>
                                    <div class="row">
                                        <div class="badge badge-primary"> تاريخ النهاية {{$assignment->end_date}}</div>
                                    </div>
                                </td>
                                <td>{{$assignment->reason}}</td>

                                <td>
                                    <a href="{{route('assignments.edit', $assignment->id)}}" class="btn btn-icons btn-rounded btn-primary btn-sm"  data-toggle="tooltip" title="تعديل"><i class="mdi mdi-pen"></i></a>
                                    <a class="btn btn-icons btn-rounded btn-danger remove-record" data-csrf="{{csrf_token()}}" data-toggle="modal" data-url="{{route('assignments.destroy', $assignment->id) }}" data-id="{{$assignment->id}}" data-target="#custom-width-modal"  title="حذف"><i class="mdi mdi-delete"></i></a>
                                </td>
                            </tr>
                        @endforeach

                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>

@endsection

@section('modals')
    @include('includes.delete-confirmation')
@endsection

@section('scripts')
    {{-- <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script> --}}
    <script src="{{ asset('js/delete-confremation.js') }}"></script>

    <script>
        $(document).ready(function(){
        $('[data-toggle="tooltip"]').tooltip();   
        });
    </script>

@endsection